local HardFinger = _G.HardFinger
local P = HardFinger.HardFinger_Config

HardFinger.ENCOUNTERS_ID = {
["EMERALD"] = {1873, 1877, 1864}, -- EN
["TOV"] = {1958, 1962, 2008}, -- TOV
["NH"] = {1849, 1865, 1867, 1871, 1862, 1842, 1886, 1872, 1863, 1866}, -- NH
["TOS"] = {2032, 2048, 2036, 2037, 2050, 2054, 2052, 2038, 2051}, -- TOS
}

COMBATLOG_OBJECT_REACTION_FRIENDLY	= COMBATLOG_OBJECT_REACTION_FRIENDLY or 0x00000010

COMBATLOG_OBJECT_TYPE_PET		= COMBATLOG_OBJECT_TYPE_PET or 0x00001000
COMBATLOG_OBJECT_TYPE_GUARDIAN		= COMBATLOG_OBJECT_TYPE_GUARDIAN or 0x00002000
COMBATLOG_OBJECT_TYPE_NPC 		= COMBATLOG_OBJECT_TYPE_NPC or 0x0000800
PET_FILTER_BITMASK			= COMBATLOG_OBJECT_TYPE_PET + COMBATLOG_OBJECT_TYPE_GUARDIAN + COMBATLOG_OBJECT_TYPE_NPC

COMBATLOG_OBJECT_AFFILIATION_RAID	=	COMBATLOG_OBJECT_AFFILIATION_RAID or 0x00000004
COMBATLOG_OBJECT_AFFILIATION_PARTY	=	COMBATLOG_OBJECT_AFFILIATION_PARTY or 0x00000002
COMBATLOG_OBJECT_AFFILIATION_MINE	=	COMBATLOG_OBJECT_AFFILIATION_MINE or 0x00000001
MINE_PARTY_RAID_BITMASK = COMBATLOG_OBJECT_AFFILIATION_RAID + COMBATLOG_OBJECT_AFFILIATION_PARTY + COMBATLOG_OBJECT_AFFILIATION_MINE

HardFinger.FailTable = {}
FailTable = HardFinger.FailTable
FailTable.Data = {}
HardFinger.WhoPulledTable = {}
WhoPulledTable = HardFinger.WhoPulledTable
HardFinger.PetOwnersTable = {}
PetOwnersTable = HardFinger.PetOwnersTable
HardFinger.MobDeathsTable = {}
MobDeathsTable = HardFinger.MobDeathsTable
HardFinger.TargetsAvailableGeneratedTable = {}
TargetsAvailableGeneratedTable = HardFinger.TargetsAvailableGeneratedTable
HardFinger.TimersTable = {}
TimersTable = HardFinger.TimersTable
HardFinger.GenericTable = {}
GenericTable = HardFinger.GenericTable
GenericTable.PlayersInfo = {}
GenericTable.UnitsForGUIDs = {}

function HardFinger.TableHardCopy(orig)
	-- Credits to http://lua-users.org/wiki/CopyTable
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[HardFinger.TableHardCopy(orig_key)] = HardFinger.TableHardCopy(orig_value)
        end
        setmetatable(copy, HardFinger.TableHardCopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end

-- Funo Targets Disponiveis
function HardFinger.GenerateTargetsTableSoakID(event, spellIDToTrack, buffOrDebuffFunc, spellIDBuffDebuff, roles, delay, message, spellID)
    if spellIDToTrack == spellID and string.find(event,message) then
		if delay == nil then
			-- Include the player for the table, if applicable
			if UnitIsDeadOrGhost("player") == false and (string.find(string.upper(roles),UnitGroupRolesAssigned("player")) or roles == "ALL") then
				TargetsAvailableGeneratedTable[event..spellIDToTrack] = {[UnitGUID("player")] = UnitName("player")}
			end

			local _,_,_,_,_,_,_,_,instanceSize = GetInstanceInfo() -- Needed to handle if people leave the group
			HardFinger.InstanceSize = instanceSize
			for i=1, instanceSize do
				if UnitIsDeadOrGhost(HardFinger.ValidUnitFrameGUID..i) == false then
					if string.find(string.upper(roles),UnitGroupRolesAssigned(HardFinger.ValidUnitFrameGUID..i)) then
						local spellNameToCheck = GetSpellInfo(spellIDBuffDebuff) -- Get Localized SpellName for UnitBuff/Debuff function
						if buffOrDebuffFunc == nil or buffOrDebuffFunc(UnitName(HardFinger.ValidUnitFrameGUID..i), spellNameToCheck) ~= nil then
							TargetsAvailableGeneratedTable[event..spellIDToTrack][UnitGUID(HardFinger.ValidUnitFrameGUID..i)] = Ambiguate(UnitName(HardFinger.ValidUnitFrameGUID..i), "short")
						end
					end
				end
			end
			HardFinger.DPrint("TargetsAvailableGeneratedTable["..event..spellIDToTrack.."] created")
		else
			HardFinger.DelayedTimer("AddANewTimer", delay, HardFinger.GenerateTargetsTableSoakID, spellIDToTrack..tostring(buffOrDebuffFunc), event, spellIDToTrack, buffOrDebuffFunc, spellIDBuffDebuff, roles, nil, message, spellID)
		end
    end
end

-- Funo Targets Disponiveis
function HardFinger.AddToTargetsTableSoakID(event, spellIDToTrack, buffOrDebuffFunc, spellIDBuffDebuff, roles, delay, message, destName, spellID)
    if HardFinger.IsIn(spellID, spellIDToTrack) and string.find(event,message) then
		if delay == nil then
			if UnitIsDeadOrGhost(destName) == false and (string.find(string.upper(roles),UnitGroupRolesAssigned(destName)) or roles == "ALL") then
			
				local hasBuffDebuff = false -- ID spells can be a list
				if buffOrDebuffFunc ~= nil then
					for k,v in pairs(spellIDBuffDebuff or {}) do
						local spellNameToCheck = GetSpellInfo(v)
						if buffOrDebuffFunc(UnitName(HardFinger.ValidUnitFrameGUID..i), spellNameToCheck) ~= nil then
							hasBuffDebuff = true
							break
						end
					end
				end
				
				if buffOrDebuffFunc == nil or hasBuffDebuff == true then
					TargetsAvailableGeneratedTable[event..spellIDToTrack][UnitGUID(destName)] = HardFinger.SName(destName)
				end
			end
			HardFinger.DPrint("TargetsAvailableGeneratedTable["..event..spellIDToTrack.."] added")
		else
			HardFinger.DelayedTimer("AddANewTimer", delay, HardFinger.AddToTargetsTableSoakID, spellIDToTrack..tostring(buffOrDebuffFunc), event, spellIDToTrack, buffOrDebuffFunc, spellIDBuffDebuff, roles, delay, message, destName, spellID)
		end
    end
end


function HardFinger.DelayedTimer(action, timer, func, timerName, ...)
	if action == "Update" then
		for k, v in pairs(TimersTable) do
			if v.endTimer <= GetTime() then
				TimersTable[k] = nil
				v.functionToCall(unpack(v.arguments))
			end
		end
	elseif action == "AddANewTimer" then
		HardFinger.DPrint(timerName.." "..tostring(func).." added") 
		if TimersTable[timerName] == nil then
			TimersTable[timerName] = {startTimer = GetTime(), endTimer = GetTime()+timer, functionToCall = func, arguments = {...}}
		end
	end
end

-- Funo Display tables
function HardFinger.DisplayTable(tableToDisplay, spellIDTrigger, messageTrigger, spellIDIcon, text, delay, shouldShow, shouldTrack, message, spellID)
    if TargetsAvailableGeneratedTable[tableToDisplay] ~= nil then
		if delay == nil then
			HardFinger.DPrint("TargetsAvailableGeneratedTable["..tableToDisplay.."]")

			local stringOfNames = ""
			for _,name in pairs(TargetsAvailableGeneratedTable[tableToDisplay]) do
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
					HardFinger.ModifyFailTable(spellIDIcon, text, name)
				end
				stringOfNames = stringOfNames..name.. ", "
			end
			if stringOfNames ~= "" then
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
					HardFinger.StringOfNames = stringOfNames:sub(1,#stringOfNames-2) -- Remove last ", "
					HardFinger.SendChat(GetSpellLink(spellIDIcon)..text, P.ReportChannel)
					HardFinger.SendChat(stringOfNames, P.ReportChannel)
				end
				wipe(TargetsAvailableGeneratedTable[tableToDisplay])
			end
		elseif spellIDTrigger == spellID and string.find(messageTrigger,message) then
			HardFinger.DPrint("TargetsAvailableGeneratedTable["..tableToDisplay.."] called to be displayed")
			HardFinger.DPrint("timer started")
			HardFinger.DelayedTimer("AddANewTimer", delay, HardFinger.DisplayTable, spellIDIcon..tostring(tableToDisplay), tableToDisplay, spellIDTrigger, messageTrigger, spellIDIcon, text, nil, shouldTrack, message, spellName, spellID)
		end
    end
end

function HardFinger.BadSpellAuraSpreadID(spellIDToTrack, safeSource, shouldShow, shouldTrack, message, spellID, sourceName, destName)
    if spellIDToTrack == spellID then
        if message == "SPELL_AURA_APPLIED" or message == "SPELL_AURA_APPLIED_DOSE" then
            local sourceName = HardFinger.SName(sourceName) -- Strip away realm name
            local destName = HardFinger.SName(destName) -- Strip away realm name
            if sourceName ~= safeSource then
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
                    HardFinger.SendChat(sourceName.." failed miserably. "..GetSpellLink(spellID).." spreaded to "..destName..".", P.ReportChannel)
                end
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
                    HardFinger.ModifyFailTable(spellID, "Bad Spread Count:", sourceName)
                end
            end
        end 
    end    
end

function HardFinger.CombatToggle(status)
	if status == "OUT_OF_COMBAT" and UnitIsDeadOrGhost("player") == false then
		wipe(WhoPulledTable)

		wipe(PetOwnersTable)
		HardFinger.WorldInfo()
	elseif status == "IN_COMBAT" then
		--
	end

end

-- Funcao announce aura applied
function HardFinger.AnnounceAuraID(spellIDToTrack, message, destName, spellID)
	if message == "SPELL_AURA_APPLIED" or message == "SPELL_AURA_APPLIED_DOSE" then
		if spellIDToTrack == spellID then
			destName = HardFinger.SName(destName) -- Strip away realm name
			HardFinger.SendChat(destName.." is affected by "..GetSpellLink(spellID)..".", P.ReportChannel)
		end
	end
end

-- Funao AURA_APPLIED, AURA_APPLIED_DOSE
function HardFinger.BadSpellAuraSpreadID(spellIDToTrack, safeSource, shouldShow, shouldTrack, message, spellID, sourceName, destName)
	if spellIDToTrack == spellID then
		if message == "SPELL_AURA_APPLIED" or message == "SPELL_AURA_APPLIED_DOSE" then
			sourceName = HardFinger.SName(sourceName) -- Strip away realm name
			destName = HardFinger.SName(destName) -- Strip away realm name
			if sourceName ~= safeSource then
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
					HardFinger.SendChat(sourceName.." failed miserably. "..GetSpellLink(spellID).." spreaded to "..destName..".", P.ReportChannel)
				end
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
					HardFinger.ModifyFailTable(spellID, "Bad Spread Count:", sourceName)
				end
			end
		end
	end
end

function HardFinger.TimedMessage(timerName, timer, channel, text, numberOfTimes)
	GenericTable[timerName] = GenericTable[timerName] or false
	local timeDiff = math.floor(GetTime() - HardFinger.EncounterTimer)
	if timer == -1 or GenericTable[timerName] == false then
		if timer == -1 or (timeDiff == timer and GenericTable[timerName] == false) then
			if channel == "RAID_WARNING" then
				for i=1,(numberOfTimes or 1) do
					SendChatMessage(text, channel)
				end
				GenericTable[timerName] = true
			end
		end
	elseif timeDiff == (timer+1) or timeDiff == 1 then
		GenericTable[timerName] = false
	end
end

-- Has Interrupts
HardFinger.InterruptTable = {}
InterruptTable = HardFinger.InterruptTable
InterruptCDs = {[187707] = {CoolDown = 15, InterruptName = "Muzzle"}, -- Survival Hunter
				[50613] = {CoolDown = 90, InterruptName = "Arcane Torrent"}, -- Arcane Torrent
				[202719] = {CoolDown = 90, InterruptName = "Arcane Torrent"}, -- Arcane Torrent
				[80483] = {CoolDown = 90, InterruptName = "Arcane Torrent"}, -- Arcane Torrent
				[1766] = {CoolDown = 15, InterruptName = ""}, -- 
				[57994] = {CoolDown = 12, InterruptName = ""}, -- 
				[31935] = {CoolDown = 15, InterruptName = ""}, -- 
				[183752] = {CoolDown = 15, InterruptName = ""}, -- 
				[147362] = {CoolDown = 24, InterruptName = ""}, -- 
				[96231] = {CoolDown = 15, InterruptName = ""}, -- 
				[15487] = {CoolDown = 45, InterruptName = ""}, -- 
				[6552] = {CoolDown = 15, InterruptName = ""}, -- 
				[32747] = {CoolDown = 90, InterruptName = ""},} -- 
function HardFinger.HasInterrupt(spellIDToTrack, roles, rolesTypes, shouldShow, shouldTrack, message, spellID, sourceGUID, destName)
    if message == "SPELL_CAST_SUCCESS" then
        for k,_ in pairs(InterruptCDs) do
            if k == spellID then
                GenericTable.PlayersInfo[sourceGUID].InterruptTable = GenericTable.PlayersInfo[sourceGUID].InterruptTable or {}
                GenericTable.PlayersInfo[sourceGUID].InterruptTable[spellID] = GetTime()+InterruptCDs[spellID].CoolDown+0.5
                break
            end
        end
		if spellIDToTrack == spellID then
			HardFinger.DPrint(GetSpellLink(spellIDToTrack).. " cast finished.")
			local textPlayerNames = ""
			for PlayerGUID, PlayerInfoTable in pairs(GenericTable.PlayersInfo) do
				local PlayerName = GenericTable.PlayersInfo[PlayerGUID].Name
				for spell, SpellLastTimeUsed in pairs(PlayerInfoTable.InterruptTable) do
					if GetTime() - SpellLastTimeUsed.CoolDown > 600 then -- If it has been too long since last time it was used, the player probably is not available (dced, left, afk...)
						GenericTable.PlayersInfo[PlayerGUID].InterruptTable[spell] = nil
					elseif GetTime() > SpellLastTimeUsed.CoolDown and UnitIsDeadOrGhost(PlayerName) == false then
						if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
							HardFinger.ModifyFailTable(spellIDToTrack, "Missed Interrupts:", PlayerName)
						end
						if SpellLastTimeUsed.InterruptName == "Arcane Torrent" then
							textPlayerNames = textPlayerNames..HardFinger.SName(PlayerName).."(Racial), "
						else
							textPlayerNames = textPlayerNames..HardFinger.SName(PlayerName)..", "                                    
						end
					end
				end
			end
			if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
				if textPlayerNames ~= "" then
					textPlayerNames = textPlayerNames:sub(1,#textPlayerNames-2) -- Remove last ", "
					HardFinger.SendChat(textPlayerNames.." failed to interrupt "..GetSpellLink(spellID), P.ReportChannel)
				end
			end
		end
	end
end

function HardFinger.DamageFromSpellExpiration(spellIDToTrack, shouldTrack, shouldShow, message, spellID, sourceName, destName)
	if spellID == spellIDToTrack and message == "SPELL_AURA_REMOVED" then
		HardFinger.LastPersonToHaveSpell = false
	end
end

-- Get everyone's spec
--/run HardFinger.UpdatePlayerSpecs()
function HardFinger.UpdatePlayerSpecs()
	for PlayerGUID, PlayerInfo in pairs(GenericTable.PlayersInfo) do
		--print("looking at"..PlayerInfo.Name)
		if PlayerInfo.SpecID == "UNKNOWN" and UnitExists(PlayerInfo.Unit) then
			--HardFinger.DPrint(PlayerInfo.Name..", "..PlayerInfo.Unit.." is w/o Spec! Querying")
			C_Timer.After(0.25, function() HardFinger.QueryInspectUpdate(PlayerGUID) end)
		end
	end
end

function HardFinger.QueryInspectUpdate(guid)
	local playerUnit = GenericTable.PlayersInfo[guid].Unit
	local playerSpecID = GenericTable.PlayersInfo[guid].SpecID
	if playerSpecID == "UNKNOWN" then
		-- Is the Unit given still valid?
		if UnitGUID(playerUnit) ~= guid then
			return
		elseif UnitExists(playerUnit) then
		HardFinger.DPrint("Requesting Info for unit = "..playerUnit)
		NotifyInspect(GenericTable.PlayersInfo[guid].Unit)
		end
	end
end

function HardFinger.WorldInfo()
	_,_,instanceType,_,_,_,_,_,instanceSize = GetInstanceInfo()
	if instanceType == 23 or instanceType == 8 then -- 5 man
		HardFinger.ProperTrigger = "DUNGEON"
	else
		HardFinger.ProperTrigger = "GENERIC"
	end
	if instanceType == 0 and not IsInGroup() then
		HardFinger.ProperChannel = "SAY"
	elseif instanceType == 17 then -- 17 = LFR
		HardFinger.ProperChannel = "INSTANCE_CHAT"
		HardFinger.ValidUnitFrameGUID = "raid"
	elseif instanceType >= 14 and instanceType <= 16 then -- 16 = Mythic Raid
		HardFinger.ProperChannel = "RAID"
		HardFinger.ValidUnitFrameGUID = "raid"
	else
		HardFinger.ProperChannel = "PARTY"
		HardFinger.ValidUnitFrameGUID = "party"
	end

	if instanceSize == 0 then
		HardFinger.InstanceSize = GetNumGroupMembers()-1
	end

	if HardFinger.ActiveEcounter ~= 0 then
		for k, v in pairs(HardFinger.ENCOUNTERS_ID) do
			if HardFinger.IsIn(HardFinger.ActiveEncounter, v) then
				HardFinger.ProperTrigger = k
				break
			end
		end
	end
	
	-- Make variables "global"
	HardFinger.InstanceType = instanceType
	HardFinger.InstanceSize = instanceSize
	HardFinger.ActiveEncounter = HardFinger.ActiveEncounter or 0
	
	-- Get everyone's spec
	HardFinger.UpdateGUIDToUnitArray()
	HardFinger.UpdatePlayerSpecs()
end

function HardFinger.IsIn(object, table)
    if type(table) ~= "table" then
        return object == table
    end
    local result = false
    for _,v in pairs(table) do
        if v == object then
            result = true
            break
        end
        
    end
    return result
end

--message, _, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, param12, param13, param14 = ...

function HardFinger.HelpfulSoakAuraID(spellToTrack, makezeros, text, roles, shouldShow, shouldTrack, message, destName, destFlags, spellID)
	if spellToTrack == spellID and bit.band(destFlags, PET_FILTER_BITMASK) == 0 then
		-- Role check
		-- local role = UnitGroupRolesAssigned(destName)
		
		-- Leaving roles filter for makezeros only
		--if string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then

			local destName = HardFinger.SName(destName)
			if message == "SPELL_AURA_APPLIED" or message == "SPELL_AURA_APPLIED_DOSE" then
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
					HardFinger.SendChat(destName.." saved the world by soaking. "..GetSpellLink(spellID)..".", P.ReportChannel)
				end
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
					if makezeros == true then
						HardFinger.MakeZerosFailTable(spellID, text, roles)
					end
					HardFinger.ModifyFailTable(spellID, text, destName)
				end
			end
		--end
	end
end

-- param13, param14, param15, param18 for damageAmount, overKillAmount, absorbAmountMissed, absorbAmount)
function HardFinger.HelpfulSoakID(spellToTrack, makezeros, text, amountThreshold, roles, shouldShow, shouldTrack, message, destName, destFlags, spellID, damageAmount, overKillAmount, absorbAmountMissed, absorbAmount)
	if spellToTrack == spellID and bit.band(destFlags, PET_FILTER_BITMASK) == 0 then
		-- Role check
		local role = UnitGroupRolesAssigned(destName)

		if string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then
			local damageTaken = -1
			local damageText = ""
			local destName = HardFinger.SName(destName)
			-- Was it fully absorbed?
			if message == "SPELL_MISSED" then
				if damageAmount == "ABSORB" then -- damageAmount is param13 which has the type of the MISS
					damageTaken = absorbAmountMissed or 0 -- Absorb goes into param15 in SPELL_MISSED
					damageText = HardFinger.FormatDamage(damageTaken)
				elseif damageAmount == "IMMUNE" then
					damageTaken = "IMMUNE"
					damageText = "<IMMUNE!>"
				end
				
			elseif message == "SPELL_DAMAGE" then
				local absorbed = absorbAmount or 0
				local overkill = overKillAmount or 0
				damageTaken = damageAmount + absorbed
				damageText = HardFinger.FormatDamage(damageTaken)
			end
	
			if damageTaken >= amountThreshold then -- If damage really happened
					HardFinger.SendChat(destName.." saved the world by soaking. "..GetSpellLink(spellID).." and got hit for "..damageText..".", P.ReportChannel)
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
				end
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
					if makezeros == true then
						HardFinger.MakeZerosFailTable(spellID, text, roles)
					end
					HardFinger.ModifyFailTable(spellID, text, destName)
				end
			end
		end
	end
end

function HardFinger.BadSpellHitID(spellToTrack, amountThreshold, roles, shouldShow, shouldTrack, message, destName, destFlags, spellID, damageAmount, overKillAmount, absorbAmountMissed, absorbAmount)
	if spellToTrack == spellID and bit.band(destFlags, PET_FILTER_BITMASK) == 0 then
		-- Role check
		local role = UnitGroupRolesAssigned(destName)
		
		if string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then

			local damageTaken = -1
			local overkill = -1
			local destName = HardFinger.SName(destName)
			local textDamage = ""
			-- Was it fully absorbed?
			if message == "SPELL_MISSED" then
				if damageAmount == "ABSORB" then -- damageAmount is param13 which has the type of the MISS
					damageTaken = absorbAmountMissed or 0 -- Absorb goes into param15 in SPELL_MISSED
					textDamage = HardFinger.FormatDamage(damageAmount)
				elseif damageAmount == "IMMUNE" then 
					damageTaken = amountThreshold
					textDamage = "IMMUNE"
				end
			elseif message == "SPELL_DAMAGE" then
				local absorbed = absorbAmount or 0
				overkill = overKillAmount or 0
				damageTaken = damageAmount + absorbed
				textDamage = HardFinger.FormatDamage(damageAmount)
			end
	
			if damageTaken >= amountThreshold then
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
					local TextMessage = destName.." failed miserably. "..GetSpellLink(spellID).." Hit:  "..textDamage.."."
					if overkill > 0 then
						TextMessage = TextMessage.." Overkill: "..HardFinger.FormatDamage(overkill).."."
					end
					HardFinger.SendChat(TextMessage, P.ReportChannel)
				end
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
					HardFinger.ModifyFailTable(spellID, "Total times hit: ", destName)
				end
			end
		end
	end
end

function HardFinger.SpellAuraRemoved(spellIDToTrack, text, shouldShow, shouldTrack, message, spellID, sourceName)
	if message == "SPELL_AURA_REMOVED" then
		if spellID == spellIDToTrack then
			if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
				HardFinger.SendChat(sourceName.." failed miserably. "..GetSpellLink(spellID).." removed.", P.ReportChannel)
			end
			if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
				HardFinger.ModifyFailTable(spellID, text, destName)
			end
		end
	end
end

function HardFinger.BadSpellHitIDDeath(spellToTrack, amountThreshold, roles, shouldShow, shouldTrack, message, destName, destFlags, spellID, damageAmount, overKillAmount, absorbAmount)
	if spellToTrack == spellID and (message == "SPELL_DAMAGE" or message == "SPELL_PERIODIC_DAMAGE") and bit.band(destFlags, PET_FILTER_BITMASK) == 0 then
		local overkill = overKillAmount or 0
		if overkill > 0 then
			destName = HardFinger.SName(destName) -- Strip away realm name
			local role = UnitGroupRolesAssigned(destName)
			if string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then
				local absorbed = absorbAmount or 0
				local damageTaken = damageAmount + absorbed
	
				if damageTaken >= amountThreshold then
					if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
						HardFinger.SendChat(destName.." failed miserably. "..GetSpellLink(spellID).." Hit: "..HardFinger.FormatDamage(damageTaken)..". Overkill: "..HardFinger.FormatDamage(damageTaken-overKillAmount)..".", P.ReportChannel)
					end
					if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
						HardFinger.ModifyFailTable(spellID, "Deaths: ", destName)
					end
				end
			end
		end
	end
end

function HardFinger.toggletf(variable)
	if variable ~= true then		return true	else		return false	end
end

function HardFinger.toggle01(variable)
	if variable ~= 1 then		return 1	else		return 0	end
end


function HardFinger.StatusText(variable)
	if variable ~= 1 and variable ~= true then
		return "|cffff0000Off"
	else
		return "|c0000FF00On"
	end
end

HardFinger.LastHitTimerSpell = {}
LastHitTimerSpell = HardFinger.LastHitTimerSpell

function HardFinger.UniqueSpellHitInInterval(spellIDToTrack, interval, message, spellID, destName, absorbAmountMissed)
	local damageTaken = -1
	local destName = HardFinger.SName(destName)

	-- Was it fully absorbed?
	if message == "SPELL_MISSED" and damageAmount == "ABSORB" then -- damageAmount is param13 which has the type of the MISS
		damageTaken = absorbAmountMissed or 0 -- Absorb goes into param15 in SPELL_MISSED
	
	elseif message == "SPELL_DAMAGE" then
		local absorbed = absorbAmount or 0
		local overkill = overKillAmount or 0
		damageTaken = damageAmount + absorbed
	end
	
	if damageTaken > 0 then -- If damage really happened
		if GetTime() - (LastHitTimerSpell[spellID] or 0) > interval then
			if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
				HardFinger.SendChat(destName.." saved the world by soaking. "..GetSpellLink(spellID)..".", P.ReportChannel)
			end
			if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
				HardFinger.ModifyFailTable(spellID, "Soaks: ", destName)
			end
		end
		LastHitTimerSpell[spellID] = GetTime()
	end
end
-- Funcao remove from table
function HardFinger.RemoveFromTableIDbyEvent(tableToModify, event, spellIDToTrack, message, tableKey, spellID)
	if TargetsAvailableGeneratedTable[tableToModify] == nil or TargetsAvailableGeneratedTable[tableToModify] == {} then
		return
	end
	if HardFinger.IsIn(spellID, spellIDToTrack) and string.find(event,message) then
		if TargetsAvailableGeneratedTable[tableToModify][tableKey] == nil then
			HardFinger.DPrint("key = "..tableKey.." does not exists.")
			return
		end
		TargetsAvailableGeneratedTable[tableToModify][tableKey] = nil
	end
end

function HardFinger.FindOwnerPetFromGUID(petName,petGUID) -- Credits to Recount

	local ownerName
	local ownerGUID
	local ownerRealm
	if PetOwnersTable[petGUID] ~= nil then
		return PetOwnersTable[petGUID][1], PetOwnersTable[petGUID][2]
    end

	if petGUID==UnitGUID("pet") then
		ownerName = UnitName("player")

		ownerGUID = UnitGUID("player")
		PetOwnersTable[petGUID] = {ownerName, ownerGUID}
		return ownerName, ownerGUID

	end
	
	local _,_,_,_,_,_,_,_,instanceSize = GetInstanceInfo() -- Needed to handle if people leave the group
	HardFinger.InstanceSize = instanceSize
		
	if HardFinger.InstanceSize > 0 then
		for i = 1, HardFinger.InstanceSize, 1 do -- GetNumRaidMembers()
			if petGUID == UnitGUID("raidpet"..i) then
				ownerName, ownerRealm = UnitName("raid"..i)
				if ownerRealm then
					ownerName = ownerName .. "-" .. ownerRealm
				end
				ownerGUID = UnitGUID("raid"..i)
				PetOwnersTable[petGUID] = {ownerName, ownerGUID}
				return ownerName, ownerGUID
			end
		end
	end
	HardFinger.DPrint(petName.." owner not found")
	return petName, petGUID
end

function HardFinger.DamageToTarget(targetNameToTrack, desc, message, sourceGUID, sourceName, sourceFlags, destName, spellID, damageAmount, overKillAmount, absorbAmount)
	if (message == "SPELL_DAMAGE" or message == "SPELL_PERIODIC_DAMAGE" or message == "SWING_DAMAGE") then
		if string.find(string.upper(destName),string.upper(targetNameToTrack)) then
			local absorbed, damaged, damageDone
			if message == "SPELL_DAMAGE" or message == "SPELL_PERIODIC_DAMAGE" then
				absorbed = absorbAmount or 0
				damaged = damageAmount or 0
			else
				absorbed = absorbAmount or 0
				damaged = spellID or 0 -- For melee swings, damageAmount is the same nth parameter as spellID
				spellName = "Melee Swing"
			end
			damageDone = damaged + absorbed

			local sourceDamage = sourceName
			if bit.band(sourceFlags, PET_FILTER_BITMASK) ~= 0 then
				sourceDamage,_ = HardFinger.FindOwnerPetFromGUID(sourceName, sourceGUID)
			end

			if desc ~= nil and sourceDamage ~= nil and damageDone ~= nil then -- Not necessary, but just to be safe
				HardFinger.ModifyFailTable(desc, "Damage Done ["..targetNameToTrack.."]: ", sourceDamage, damageDone)
			end
		end
	end
end

FIXED_CLASS_ROLES = {
["WARLOCK"] = {Role = "DAMAGER", RoleType = "RANGED"},
["MAGE"] = {Role = "DAMAGER", RoleType = "RANGED"},
["ROGUE"] = {Role = "DAMAGER", RoleType = "MELEE"},
}

SPECS_INFO = {
[250] = {Class = "DEATHKNIGHT", SpecSpecName = "BLOOD", Role = "TANK", RoleType = "MELEE"},
[251] = {Class = "DEATHKNIGHT", SpecName = "FROST", Role = "DAMAGER", RoleType = "MELEE"},
[252] = {Class = "DEATHKNIGHT", SpecName = "UNHOLY", Role = "DAMAGER", RoleType = "MELEE"},
[577] = {Class = "DEMOHUNTER", SpecName = "HAVOC", Role = "DAMAGER", RoleType = "MELEE"},
[581] = {Class = "DEMOHUNTER", SpecName = "VENGEANCE", Role = "TANK", RoleType = "MELEE"},
[102] = {Class = "DRUID", SpecName = "BALANCE", Role = "DAMAGER", RoleType = "RANGED"},
[103] = {Class = "DRUID", SpecName = "FERAL", Role = "DAMAGER", RoleType = "MELEE"},
[104] = {Class = "DRUID", SpecName = "GUARDIAN", Role = "TANK", RoleType = "MELEE"},
[105] = {Class = "DRUID", SpecName = "RESTORATION", Role = "HEALER", RoleType = "RANGED"},
[253] = {Class = "HUNTER", SpecName = "BEASTMASTERY", Role = "DAMAGER", RoleType = "RANGED"},
[254] = {Class = "HUNTER", SpecName = "MARKSMANSHIP", Role = "DAMAGER", RoleType = "RANGED"},
[255] = {Class = "HUNTER", SpecName = "SURVIVAL", Role = "DAMAGER", RoleType = "MELEE"},
[62] = {Class = "MAGE", SpecName = "ARCANE", Role = "DAMAGER", RoleType = "RANGED"},
[63] = {Class = "MAGE", SpecName = "FIRE", Role = "DAMAGER", RoleType = "RANGED"},
[64] = {Class = "MAGE", SpecName = "FROST", Role = "DAMAGER", RoleType = "RANGED"},
[268] = {Class = "MONK", SpecName = "BREWMASTER", Role = "TANK", RoleType = "MELEE"},
[270] = {Class = "MONK", SpecName = "MISTWEAVER", Role = "HEALER", RoleType = "RANGED"},
[269] = {Class = "MONK", SpecName = "WINDWALKER", Role = "DAMAGER", RoleType = "MELEE"},
[65] = {Class = "PALADIN", SpecName = "HOLY", Role = "HEALER", RoleType = "RANGED"},
[66] = {Class = "PALADIN", SpecName = "PROTECTION", Role = "TANK", RoleType = "MELEE"},
[70] = {Class = "PALADIN", SpecName = "RETRIBUTION", Role = "DAMAGER", RoleType = "MELEE"},
[256] = {Class = "PRIEST", SpecName = "DISCIPLINE", Role = "HEALER", RoleType = "RANGED"},
[257] = {Class = "PRIEST", SpecName = "HOLY", Role = "HEALER", RoleType = "RANGED"},
[258] = {Class = "PRIEST", SpecName = "SHADOW", Role = "DAMAGER", RoleType = "RANGED"},
[259] = {Class = "ROGUE", SpecName = "ASSASSINATION", Role = "DAMAGER", RoleType = "MELEE"},
[260] = {Class = "ROGUE", SpecName = "OUTLAW", Role = "DAMAGER", RoleType = "MELEE"},
[261] = {Class = "ROGUE", SpecName = "SUBTLETY", Role = "DAMAGER", RoleType = "MELEE"},
[262] = {Class = "SHAMAN", SpecName = "ELEMENTAL", Role = "DAMAGER", RoleType = "RANGED"},
[263] = {Class = "SHAMAN", SpecName = "ENHANCEMENT", Role = "DAMAGER", RoleType = "MELEE"},
[264] = {Class = "SHAMAN", SpecName = "RESTORATION", Role = "HEALER", RoleType = "RANGED"},
[265] = {Class = "WARLOCK", SpecName = "AFFLICTION", Role = "DAMAGER", RoleType = "RANGED"},
[266] = {Class = "WARLOCK", SpecName = "DEMONOLOGY", Role = "DAMAGER", RoleType = "RANGED"},
[267] = {Class = "WARLOCK", SpecName = "DESTRUCTION", Role = "DAMAGER", RoleType = "RANGED"},
[71] = {Class = "WARRIOR", SpecName = "ARMS", Role = "DAMAGER", RoleType = "MELEE"},
[72] = {Class = "WARRIOR", SpecName = "FURY", Role = "DAMAGER", RoleType = "MELEE"},
[73] = {Class = "WARRIOR", SpecName = "PROTECTION", Role = "TANK", RoleType = "MELEE"},
["UNKNOWN"] = {SpecName = "UNKNOWN", Role = "UNKNOWN", RoleType = "UNKNOWN"},
}

--/dump _G.HardFinger.GetAllPlayerInfoByName(UnitGUID("mouseover"))
function HardFinger.GetAllPlayerInfoByName(playerGUID)
	GenericTable.PlayersInfo[playerGUID] = GenericTable.PlayersInfo[playerGUID] or {}
	local PlayerInfo = GenericTable.PlayersInfo[playerGUID]
	
	if playerGUID == nil then HardFinger.DPrint("HardFinger - Player is not in your group. Impossible to retrieve Player Info") return end
	local nonLocalizedClass, LocalizedClass, nonLocalizedRace, LocalizedRace, Sex, Name, _ = GetPlayerInfoByGUID(playerGUID)
	GenericTable.PlayersInfo[playerGUID].GUID = playerGUID
	GenericTable.PlayersInfo[playerGUID].Class = LocalizedClass
	GenericTable.PlayersInfo[playerGUID].Sex = Sex
	GenericTable.PlayersInfo[playerGUID].Name = Name
	GenericTable.PlayersInfo[playerGUID].SpecID = GenericTable.PlayersInfo[playerGUID].SpecID or "UNKNOWN"
	GenericTable.PlayersInfo[playerGUID].SpecName = SPECS_INFO[GenericTable.PlayersInfo[playerGUID].SpecID].SpecName or GenericTable.PlayersInfo[playerGUID].Spec
	GenericTable.PlayersInfo[playerGUID].Role = SPECS_INFO[GenericTable.PlayersInfo[playerGUID].SpecID].Role or GenericTable.PlayersInfo[playerGUID].Role
	GenericTable.PlayersInfo[playerGUID].RoleType = SPECS_INFO[GenericTable.PlayersInfo[playerGUID].SpecID].RoleType or GenericTable.PlayersInfo[playerGUID].RoleType
	GenericTable.PlayersInfo[playerGUID].Unit = HardFinger.GUIDToUnit(playerGUID)
				
	if FIXED_CLASS_ROLES[LocalizedClass] then
		GenericTable.PlayersInfo[playerGUID].Role = FIXED_CLASS_ROLES[LocalizedClass].Role
		GenericTable.PlayersInfo[playerGUID].RoleType = FIXED_CLASS_ROLES[LocalizedClass].RoleType
	else
		GenericTable.PlayersInfo[playerGUID].Role = UnitGroupRolesAssigned(GenericTable.PlayersInfo[playerGUID].Name)
		
		-- If it is a tank, obviously it is melee
		if GenericTable.PlayersInfo[playerGUID].Role == "TANK" then
			GenericTable.PlayersInfo[playerGUID].RoleType = "MELEE"
			
		-- If it is a tank, obviously it is ranged. I know holy paladins and monks are considered melee, but for the sake of proximity-mechanics, they will be considered Ranged (as they can be both and ranged is less-limiting)	
		elseif GenericTable.PlayersInfo[playerGUID].Role == "HEALER" then
			GenericTable.PlayersInfo[playerGUID].RoleType = "RANGED"
		elseif GenericTable.PlayersInfo[playerGUID].Role == "DAMAGER" then
			-- If they are a class that the DPS spec is only melee, they are melee
			if GenericTable.PlayersInfo[playerGUID].Class == "PALADIN" or GenericTable.PlayersInfo[playerGUID].Class == "DEATHKNIGHT" or GenericTable.PlayersInfo[playerGUID].Class == "MONK" or GenericTable.PlayersInfo[playerGUID].Class == "WARRIOR" or GenericTable.PlayersInfo[playerGUID].Class == "DEMONHUNTER" then
				GenericTable.PlayersInfo[playerGUID].RoleType = "MELEE"
			
			-- If they are a class that the DPS spec is only ranged, they are ranged			
			elseif GenericTable.PlayersInfo[playerGUID].Class == "PRIEST" then
				GenericTable.PlayersInfo[playerGUID].RoleType = "RANGED"
				
			-- Enhancement shamans have 150 max maelstrom, otherwise they are elemental
			elseif GenericTable.PlayersInfo[playerGUID].Class == "SHAMAN" then
				if UnitPowerMax == 150 then 
					GenericTable.PlayersInfo[playerGUID].RoleType = "MELEE"
				else
					GenericTable.PlayersInfo[playerGUID].RoleType = "RANGED"
				end
			elseif CanInspect(Name) then
			-- All that is left is Druid and Hunters that can't be guessed w/o proper inspect. So lets inspect them to retrieve precise information for a next use
				HardFinger.DPrint("Calling NotifyInspect for unit = "..tostring(GenericTable.PlayersInfo[playerGUID].Unit) or "nil")
				NotifyInspect(GenericTable.PlayersInfo[playerGUID].Unit)
				
			end
		end
	end

	return PlayerInfo
end

function HardFinger.GUIDToUnit(guid)
	--HardFinger.DPrint("Searching unit for.."..guid)
	local unit = GenericTable.UnitsForGUIDs[guid]
	--if unit ~= nil then
	--	HardFinger.DPrint("Unit Found! Unit = .."..unit)
	--end
	return unit
end

function HardFinger.UpdateGUIDToUnitArray()
	HardFinger.DPrint("Something changed within the group!");
	wipe(GenericTable.UnitsForGUIDs or {})
	GenericTable.UnitsForGUIDs[UnitGUID("player")] = "player"
	local count = 1
	if UnitExists('pet') then
		GenericTable.UnitsForGUIDs[UnitGUID("pet")] = "pet";
		count = count + 1
	end
	
	for i = 1, HardFinger.InstanceSize, 1 do -- GetNumRaidMembers()
		if UnitExists(HardFinger.ValidUnitFrameGUID..i) then
			GenericTable.UnitsForGUIDs[UnitGUID(HardFinger.ValidUnitFrameGUID..i)] = HardFinger.ValidUnitFrameGUID..i
			--HardFinger.DPrint(GenericTable.UnitsForGUIDs[UnitGUID(HardFinger.ValidUnitFrameGUID..i)].." added as = "..HardFinger.ValidUnitFrameGUID..i)
			count = count + 1
		end
		if UnitExists(HardFinger.ValidUnitFrameGUID..i.."pet") then
			GenericTable.UnitsForGUIDs[UnitGUID(HardFinger.ValidUnitFrameGUID..i.."pet")] = HardFinger.ValidUnitFrameGUID..i.."pet"
			count = count + 1
		end
	end
	for k, v in pairs(GenericTable.UnitsForGUIDs) do
	--print(k,v)
	end
	HardFinger.DPrint("Party-Data updated - "..count.." Members in list");
end

local unitstrings = {
  raid = { "player" }, -- This seems to be needed under certain circumstances.
  party = { "player" }, -- Player not part of partyN
  player = { "player" }
}
for i = 1,40 do table.insert (unitstrings.raid, "raid"..i) end
for i = 1,4  do table.insert (unitstrings.party, "party"..i) end

-- Returns an array with the set of unit ids for the current group
function HardFinger.GroupUnits()
  local units
  if IsInRaid () then
    units = unitstrings.raid
  elseif GetNumSubgroupMembers () > 0 then
    units = unitstrings.party
  else
    units = unitstrings.player
  end
  return units
end


function HardFinger.BadSpellAuraID(spellIDToTrack, text, stackAmount, modulo, shouldShow, shouldTrack, message, destName, spellID, numberOfStacks)
-- numberOfStacks = param14
	if spellIDToTrack == spellID then
		if message == "SPELL_AURA_APPLIED" or message == "SPELL_AURA_APPLIED_DOSE" then
			destName = HardFinger.SName(destName) -- Strip away realm name
			if stackAmount == -1 then
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
					HardFinger.SendChat(destName.." has failed miserably. "..GetSpellLink(spellID))
				end
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
					HardFinger.ModifyFailTable(spellID, text, destName, 1) -- Increment by 1
				end
			elseif numberOfStacks ~= nil and numberOfStacks > stackAmount then
				if modulo == nil or modulo == -1 then
					if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
						HardFinger.SendChat(destName.." has failed miserably. "..GetSpellLink(spellID).." "..numberOfStacks.." stacks.", P.ReportChannel)
					end
					if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
						HardFinger.ModifyFailTable(spellID, text, destName, nil, numberOfStacks)
					end
				elseif stackAmount >= numberOfStacks and mod(numberOfStacks-stackAmount, modulo) == 0 then
					if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
						HardFinger.SendChat(destName.." has failed miserably. "..GetSpellLink(spellID).." "..numberOfStacks.." stacks.", P.ReportChannel)
					end
					if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
						HardFinger.ModifyFailTable(spellID, text, destName, nil, numberOfStacks)
					end
				end
			end
		end
	end
end


function HardFinger.DisplayFailTable(call)
	--HardFinger.DPrint("Entered function displayFailTable")
	if call == "HRESET" then
		wipe(FailTable.Data or {})
		wipe(FailTable.Header or {})
		HardFinger.DPrint("Failtable HReset")
		return
	end
	-- Check whether FailTable is empty, if so, return
	local next = next
	if next(FailTable.Data) == nil then
		HardFinger.DPrint("failTable is empty")
	else
		HardFinger.FailTableDelayTimer = HardFinger.FailTableDelayTimer or GetTime()
		if (GetTime() - HardFinger.FailTableDelayTimer) > 1 then
			HardFinger.DPrint("failTable being displayed") -- Debug only
			
			-- Print HardFinger report + Attempt# header
			
			local header = "HardFinger Report"
			
			local next = next
			if next(FailTable.Header or {}) ~= nil then
				header = header.." for "..FailTable.Header.EncounterName.. " - " ..FailTable.Header.Attempt
			end
			HardFinger.SendChat(header, P.ReportChannel)
			
			
			for spell,spellTable in pairs(FailTable.Data) do
				local counter = ""
				if HardFinger.IsIn(spellTable.description, {"Total times hit: ", "Deaths: ", " Frozen", " Fear applications: ", " Souls absorbed: ", " Bombs Applications: ", " Cakes Eaten: ", " Players Frozen: "}) == true then
					counter, counter2 = HardFinger.SumVectorValues(spellTable.players)
				end
				local counter2text = ""
				if counter2 ~= nil then
					-- counter2text = "#Players: "..counter2
				end
				-- spell Icon
				spellIconTextOrLink = spellTable.spellIcon
				if type(spellTable.spellIcon) == "number" then
					spellIconTextOrLink = (GetSpellLink(spellTable.spellIcon))
				end
				HardFinger.SendChat(spellIconTextOrLink.." "..(spellTable.description)..counter..counter2text, P.ReportChannel)
				local textRows = {[1] = ""}
				local index = 1
				for _,unit in HardFinger.Spairs(spellTable.players, function(t,a,b) return t[b].counter < t[a].counter end) do
					if #textRows[index] > 220 then
						index = index + 1
					end
					textToAdd = HardFinger.SName(unit.name).."  "..HardFinger.FormatDamage(unit.counter).. ", "
					textRows[index] = (textRows[index] or "")..textToAdd
				end
				textRows[index] = textRows[index]:sub(1,#textRows[index]-2) -- Remove last ", " from the last textRow
				
				for i=1, #textRows do
					HardFinger.SendChat(textRows[i], P.ReportChannel)
				end
			end
			--wipe(FailTable)
			HardFinger.FailTableDelayTimer = nil
		end
	end
end

-- Funao bad SPELL_DAMAGE spread
function HardFinger.BadSpreadDamageID(spellToTrack, unitName, amountThreshold, roles, shouldShow, shouldTrack, message, sourceName, destName, spellID, damageTaken, overkill)
    if spellToTrack == spellID then
        if message == "SPELL_DAMAGE" or message == "SPELL_ABSORB" then
            absorbed = absorbed or 0
            damageTaken = damageTaken + absorbed
            sourceName = HardFinger.SName(sourceName) -- Strip away realm name
            destName = HardFinger.SName(destName) -- Strip away realm name
            if sourceName ~= destName then
                if sourceName ~= unitName then
                    local role = UnitGroupRolesAssigned(sourceName)
                    if string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then
                        if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
                            HardFinger.SendChat(sourceName.." hit "..destName.." "..GetSpellLink(spellID).." "..damageTaken, P.ReportChannel)                
                        end   
                        if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
                            HardFinger.ModifyFailTable(spellID, "Spread Fail [Friendly Fire]: ", sourceName, damageTaken)
                        end
                    end
                end
            end
        end
    end
end

function HardFinger.BadSpellDamageID(spellIDToTrack, amountThreshold, roles, shouldShow, shouldTrack, message, destName, destFlags, spellID, damageAmount, overKillAmount, absorbAmountMissed, absorbAmount)
	if spellIDToTrack == spellID and bit.band(destFlags, PET_FILTER_BITMASK) == 0 then
		-- Role check
		local role = UnitGroupRolesAssigned(destName)
		if string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then
		
			local damageTaken = -1
			local destName = HardFinger.SName(destName)
			-- Was it fully absorbed?
			if message == "SPELL_MISSED" and damageAmount == "ABSORB" then
				damageTaken = absorbAmountMissed or 0 -- Absorb goes into param15 in SPELL_MISSED

				
			elseif message == "SPELL_DAMAGE" or message == "SPELL_PERIODIC_DAMAGE" then
				local absorbed = absorbAmount or 0
				local overkill = overKillAmount or 0
				damageTaken = damageAmount + absorbed
			end
			
			if damageTaken >= amountThreshold then
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
					HardFinger.SendChat(destName.." failed miserably. "..GetSpellLink(spellID).." hit for "..HardFinger.FormatDamage(damageTaken)..".", P.ReportChannel)
				end
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
					HardFinger.ModifyFailTable(spellID, "Total damage taken: ", destName, damageTaken)
				end
			end
		end
	end
end

function HardFinger.Spairs(t, order)
	-- collect the keys
	local keys = {}
	for k in pairs(t) do
		keys[#keys+1] = k
	end
	-- if order function given, sort by it by passing the table and keys a, b,
	-- otherwise just sort the keys
	if order then
		table.sort(keys, function(a,b) return order(t, a, b) end)
	else
		table.sort(keys)
	end
	-- return the iterator function
	local i = 0
	return function()
		i = i + 1
		if keys[i] then
			return keys[i], t[keys[i]]
		end
	end
end

--Funcao Announce Dispel

function HardFinger.AnnounceDispel(spellToTrack, message, sourceName, destName, debuff)
	if message == "SPELL_DISPEL" then
		if param14 == spellToTrack then
			sourceName = HardFinger.SName(sourceName) -- Strip away realm name
			destName = HardFinger.SName(destName) -- Strip away realm name
			HardFinger.SendChat(sourceName.." has dispeled "..debuff.." from "..destName..".", P.ReportChannel)
		end

	end

end


function HardFinger.MobDeaths(Reset, SendReport, mobName, message, spellID, destName, param14)
	if Reset == true then
		MobDeathsTable[mobName] = 0
	elseif SendReport == true and MobDeathsTable[mobName] ~= nil then
		HardFinger.SendChat("Total "..mobName.." killed: "..MobDeathsTable[mobName]..".", P.ReportChannel)
		wipe(MobDeathsTable)
	elseif message == "SPELL_DAMAGE" then
		if destName == mobName and param14 > 0 and MobDeathsTable[mobName] ~= nil then
			MobDeathsTable[mobName] = MobDeathsTable[mobName] + 1
		end
	end
end

function HardFinger.TauntRezLust(message, sourceName, sourceRaidFlags, destName, destFlags, destRaidFlags, spellID)
	if bit.band(destFlags, MINE_PARTY_RAID_BITMASK) ~= 0 then
		-- 6795 = Growl, 62124 = Hand of Reckoning, 355 = Taunt, 116189 = Provoke, 185245 = Torment, 56222 = Dark Command
		if P.Taunt == true and HardFinger.IsIn(spellID, {6795, 62124, 355, 116189, 185245, 56222}) then
			-- 6795 = Growl, 62124 = Hand of Reckoning, 355 = Taunt, 116189 = Provoke, 185245 = Torment, 56222 = Dark Command
			if message == "SPELL_AURA_APPLIED" then
				rIcon = HardFinger.GetRaidMarkByFlags(destRaidFlags)
				destName = HardFinger.SName(destName)
				sourceName = HardFinger.SName(sourceName)
				HardFinger.SendChat(sourceName.." "..GetSpellLink(spellID).."'d "..rIcon..destName..rIcon..".", P.ReportChannel)
			end
		elseif message == "SPELL_CAST_SUCCESS" then
			--61999 = Raise Ally, 20484 = Rebirth, 20707 = Soulstone, 21169 = Reincarnation
			if P.BattleRez == true and HardFinger.IsIn(spellID, {61999, 20484, 20707, 21169}) then
				if spellID == 21169 then
					rIcon = HardFinger.GetRaidMarkByFlags(sourceRaidFlags)
					HardFinger.SendChat(rIcon..sourceName..rIcon.." used "..GetSpellLink(spellID)..".", P.ReportChannel)
				else
					rIcon = HardFinger.GetRaidMarkByFlags(destRaidFlags)
					HardFinger.SendChat(sourceName.." used "..GetSpellLink(spellID).." on "..rIcon..destName..rIcon..".", P.ReportChannel)
				end
			--90355 = Hysteria (hunter pet), 2825 = Blood Lust, 80353 = Time Warp, 178207 = Drums of Fury, 230935 = Drums of the Mountain
			elseif P.BloodLust and HardFinger.IsIn(spellID, {90355, 2825, 80353, 178207, 230935}) then
				HardFinger.SendChat(sourceName.." used "..GetSpellLink(spellID)..".", P.ReportChannel)
			end
		end
	end
end

function HardFinger.WhoRezzed(message, sourceName, destName, destFlags, destRaidFlags, spellID)
	if message == "SPELL_CAST_SUCCESS" then
		--61999 = Raise Ally, 20484 = Rebirth, 20707 = Soulstone
        	if HardFinger.IsIn(spellID, {61999, 20484, 20707}) then
				if bit.band(destFlags, MINE_PARTY_RAID_BITMASK) ~= 0 then
					rIcon = HardFinger.GetRaidMarkByFlags(destRaidFlags)
					HardFinger.SendChat(sourceName.." used "..GetSpellLink(spellID).." on "..rIcon..destName..rIcon..".", P.ReportChannel)
				end
			end
	end
end

function HardFinger.WhoLusted(message, sourceName, spellID)
	if message == "SPELL_CAST_SUCCESS" then
		--2825 = Blood Lust, 80353 = Time Warp, 178207 = Drums of Fury
        	if HardFinger.IsIn(spellID, {2825, 80353, 178207}) then
					HardFinger.SendChat(sourceName.." used "..GetSpellLink(spellID)..".", P.ReportChannel)
		end
	end
end

function HardFinger.RetrieveWhoPulled(tableetry, destRaidFlags)
	if WhoPulledTable[tableetry] ~= nil then
		local WPName = WhoPulledTable[tableetry].WhoPulled
		local WPSpellLink = GetSpellLink(WhoPulledTable[tableetry].SpellPulled)
		local MobIcon = HardFinger.GetRaidMarkByFlags(destRaidFlags)
		local WPTimeDiff = format(" %.1fs", GetTime() - WhoPulledTable[tableetry].TimePulled)
		local text = WPName.." pulled "..MobIcon..UnitName("target")..MobIcon.." with "..WPSpellLink..WPTimeDiff.." ago."
		HardFinger.SendChat(text, P.WhoPulledChannel)
	else
		print("HardFinger - Invalid target to retrieve information about WhoPulled.")
	end
end

function HardFinger.WhoPulled(name, beforeTimer, message, sourceGUID, sourceName, destGUID, destName, destFlags, spellID, specialUniqueKey)
	if WhoPulledTable[specialUniqueKey or destGUID] == nil then
		if (string.find(name, destName or "") or name == "ALL") and spellID ~= 137619 and spellID ~= 203528 and spellID ~= 185365 then
			if message == "SPELL_DAMAGE" or message == "SPELL_AURA_APPLIED" or message == "SPELL_AURA_APPLIED_DOSE" then
				if string.find(sourceGUID, "Player") or string.find(sourceGUID, "Pet") then
					if bit.band(destFlags, COMBATLOG_OBJECT_REACTION_FRIENDLY) == 0 then
						if sourceName ~= destName then
							-- Get the name of who pulled this mob
							local wpname = HardFinger.SName(sourceName)
							local temptext = wpname

							-- If its a pet, get owner instead
							if bit.band(sourceFlags, PET_FILTER_BITMASK) ~= 0 then
								local petname = wpname
								-- get owner name
								wpname = HardFinger.SName(HardFinger.FindOwnerPetFromGUID(sourceName, sourceGUID))
								temptext = petname.." ("..wpname.."'s pet)"
							end
	                            
							local text = temptext.." aggroed "..destName.." with "..GetSpellLink(spellID)
							if beforeTimer == true and GetTime() < (HardFinger.DBMPullTimer or 0)-0.1 then
								local diff = HardFinger.DBMPullTimer - GetTime()
								diff = format("%.1fs", diff)
								text = text.." ("..diff.." before DBM Pull)"
							end
							if name == "ALL" then
								if HardFinger.HardFinger_Config.WhoPulled == true then
									HardFinger.SendChat(text, P.WhoPulledChannel)
								end
							else
								HardFinger.SendChat(text, P.ReportChannel)
							end
							
							WhoPulledTable[specialUniqueKey or destGUID] = {WhoPulled = wpname, SpellPulled = spellID, TimePulled = GetTime()}
						end
					end
				end
			end
		end
	end
end

-- Funo sName (short name, strip away realm name)
function HardFinger.SName(name)
	if name == nil or name:find("-") == nil then
		return name
	else
		return name:match("(.-)-")
	end
end


function HardFinger.BuffDebuffAfterEvent(spellIDToTrack, messageToTrack, roles, func, auraName, spellIDIcon, textDesc, shouldShow, shouldTrack, message, spellID)
    if spellID == spellIDToTrack and message == messageToTrack then
		local _,_,_,_,_,_,_,_,instanceSize = GetInstanceInfo() -- Needed to handle if people leave the group
		HardFinger.InstanceSize = instanceSize
		for i = 1, HardFinger.InstanceSize, 1 do
			local iName = UnitName(HardFinger.ValidUnitFrameGUID..i)
			local role = UnitGroupRolesAssigned(iName)
			if string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then
				if UnitIsDeadOrGhost(iName or "") == false then
					if func(iName, auraName) == nil then
						if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
							HardFinger.SendChat(iName.." failed miserably and got hit by "..GetSpellLink(spellID)..".", P.ReportChannel)
						end
						if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
							HardFinger.ModifyFailTable(spellIDIcon, textDesc, iName)
						end
					end
				end
			end
        end
    end
end

function HardFinger.HealAbsorbedOrDoneOnDebuff(message, hasBuff, sourceName, destName, healabsorb)

	healabsorb = healabsorb or 0

	if message == "SPELL_HEAL" then

		if UnitDebuff(destName, hasBuff) ~= nil then

			if UnitGroupRolesAssigned(sourceName) == "HEALER" then

				--HardFinger.DPrint(sourceName, "Healed", destName, "for", healabsorb, param13, param14, param15)
				HardFinger.ModifyFailTable(206610, "Healing Absorbed: ", HardFinger.SName(sourceName), healabsorb)

			end
		end
	end

end

function HardFinger.DamageToTargetAbsorbed(targetNameToTrack, desc, spellIDShield, shouldShow, shouldTrack, message, sourceGUID, sourceName, sourceFlags, destName, spellID, damageAmount, overKillAmount, absorbAmount)
--param13, param14, param18)
	if (message == "SPELL_DAMAGE" or message == "SPELL_PERIODIC_DAMAGE" or message == "SWING_DAMAGE") then
		if string.find(string.upper(targetNameToTrack),string.upper(destName or "")) then
			local absorbed, damaged, damageDone
			if message == "SPELL_DAMAGE" or message == "SPELL_PERIODIC_DAMAGE" then
				absorbed = absorbAmount or 0
				damaged = damageAmount or 0
			else
				absorbed = absorbAmount or 0
				damaged = spellID or 0 -- For melee swings, damageAmount is the same nth parameter as spellID
				spellName = "Melee Swing"
			end
			damageDone = absorbed --+ damaged 

			local sourceDamage = sourceName
			if bit.band(sourceFlags, PET_FILTER_BITMASK) ~= 0 then
				sourceDamage,_ = HardFinger.FindOwnerPetFromGUID(sourceName, sourceGUID)
			end
		
			if desc ~= nil and sourceDamage ~= nil and damageDone ~= nil then -- Not necessary, but just to be safe
				if (shouldShow == true or shouldShow == 2 or shouldShow == 3) then
					GenericTable[targetNameToTrack.."DamageDoneShield"] = GenericTable[targetNameToTrack.."DamageDoneShield"] or {}
					-- if first entry ever for this source of damage, create a new array
					GenericTable[targetNameToTrack.."DamageDoneShield"][sourceDamage] = GenericTable[targetNameToTrack.."DamageDoneShield"][sourceDamage] or {["name"] = sourceDamage, ["counter"] = 0}
					GenericTable[targetNameToTrack.."DamageDoneShield"][sourceDamage].counter = GenericTable[targetNameToTrack.."DamageDoneShield"][sourceDamage].counter + damageDone
				end
				HardFinger.ModifyFailTable(desc, "Damage Done Absorbed on ["..targetNameToTrack.."]: ", sourceDamage, damageDone)
			end
		end
	elseif (shouldShow == true or shouldShow == 2 or shouldShow == 3) and spellID == spellIDShield then
		if message == "SPELL_AURA_REMOVED" then
			HardFinger.SendChat("Damage done to ["..targetNameToTrack.."] during "..GetSpellLink(spellIDShield), P.ReportChannel)
			local textRows = {[1] = ""}
			local index = 1
			for _,unit in HardFinger.Spairs(GenericTable[targetNameToTrack.."DamageDoneShield"] or {}, function(t,a,b) return t[b].counter < t[a].counter end) do
				if #textRows[index] > 220 then
					index = index + 1
				end
				textToAdd = HardFinger.SName(unit.name).."  "..HardFinger.FormatDamage(unit.counter).. ", "
				textRows[index] = (textRows[index] or "")..textToAdd
			end

			if textRows[1] == "" then
				HardFinger.SendChat("<No one did damage!>", P.ReportChannel)
			else
				textRows[index] = textRows[index]:sub(1,#textRows[index]-2) -- Remove last ", " from the last textRow
				for i=1, #textRows do
					HardFinger.SendChat(textRows[i], P.ReportChannel)
				end
			end
			wipe(GenericTable[targetNameToTrack.."DamageDoneShield"] or {})
		elseif message == "SPELL_AURA_APPLIED" then
			wipe(GenericTable[targetNameToTrack.."DamageDoneShield"] or {})
		end
	end
end

-- Modificar fail Table, descricao = texto no chat

function HardFinger.ModifyFailTable(spellIconOrText, description, creatureName, amountToChange, highestAmount)
	local amountToChange = amountToChange or 1
	local spelln = spellIconOrText
	if type(spelln) == "number" then
		spelln = GetSpellInfo(spellIconOrText)
	end
	local uniqueTableKey = spelln..description

	--HardFinger.DPrint("received: "..uniqueTableKey, spellIcon, description, creatureName, amountToChange)
	FailTable.Data[uniqueTableKey] = FailTable.Data[uniqueTableKey] or {}
	FailTable.Data[uniqueTableKey].description = description
	FailTable.Data[uniqueTableKey].spellIcon = spellIconOrText
	FailTable.Data[uniqueTableKey].players = FailTable.Data[uniqueTableKey].players or {}
	FailTable.Data[uniqueTableKey].players[creatureName] = FailTable.Data[uniqueTableKey].players[creatureName] or {}
	FailTable.Data[uniqueTableKey].players[creatureName].name = creatureName
	FailTable.Data[uniqueTableKey].players[creatureName].counter = FailTable.Data[uniqueTableKey].players[creatureName].counter or 0
	
	if highestAmount ~= nil then
		if highestAmount > FailTable.Data[uniqueTableKey].players[creatureName].counter then
			FailTable.Data[uniqueTableKey].players[creatureName].counter = highestAmount
		end
	else
		FailTable.Data[uniqueTableKey].players[creatureName].counter = FailTable.Data[uniqueTableKey].players[creatureName].counter + amountToChange
	end
end



-- Funao Send Chat
function HardFinger.SendChat(string, channel)
    if channel == false then
		print(string)
	elseif channel == "GUILD_CHANNEL" then
		SendChatMessage(string, "GUILD")
	elseif (tonumber(P.ReportChannel) or 0) ~= 1 then
		SendChatMessage(string, "CHANNEL", nil, P.ReportChannel)
	else
		SendChatMessage(string, HardFinger.ProperChannel)
	end
end

-- Somar valores para vetor
function HardFinger.SumVectorValues(vector)

	local sum = 0

	local totalEntries = 0

	for _, v in pairs(vector) do
		sum = sum + v.counter

		totalEntries = totalEntries + 1

	end
	return sum, totalEntries

end

-- Formatar damage properly
function HardFinger.FormatDamage(damage)
    local ret = damage
	if type(damage) == "number" then
		if damage > 1e6 then
			ret = format("%.1f M", damage / 1e6) -- million
		elseif damage > 1e3 then
			ret = format("%.1f K", damage / 1e3) -- thousand
		end
	end
    return ret
end

HardFinger.SterilizeTable = {}
SterilizeTable = HardFinger.SterilizeTable
function HardFinger.SterilizeUptime(message, destName, spellID)
	if HardFinger.LastEncounter == 1867 and HardFinger.ActiveEncounter == 0 then
		forceEnd = true
	end

	if message == "SPELL_AURA_APPLIED" then -- or message == "SPELL_AURA_REFRESH" then
		if spellID == 208499 or spellID == 211615 then
			SterilizeTable[destName] = SterilizeTable[destName] or {}
			SterilizeTable[destName].count = SterilizeTable[destName].count or 0
			SterilizeTable[destName].buffUptime = SterilizeTable[destName].buffUptime or 0
			SterilizeTable[destName].lastApplied = GetTime()
		end
	end

	if SterilizeTable ~= nil and SterilizeTable ~= {} then
		if forceEnd == true then
			for player, innerTable in pairs(SterilizeTable) do
				HardFinger.DPrint("[Sterilize] Final balance for player..", player)
			    balance = GetTime() - innerTable.lastApplied
			    innerTable.buffUptime = innerTable.buffUptime + balance
			end
			forceEnd = false
			HardFinger.ComputeSterilize()
			return
		end
		
		if spellID == 212103 and (message == "SPELL_DAMAGE" or message == "SPELL_PERIODIC_DAMAGE" or message == "SPELL_ABSORB") then
			SterilizeTable[destName].count = SterilizeTable[destName].count + 1
		end
		if message == "SPELL_AURA_REMOVED" and spellID == 208499 then
			balance = GetTime() - SterilizeTable[destName].lastApplied
			SterilizeTable[destName].buffUptime = SterilizeTable[destName].buffUptime + balance
		end

	end
end

function HardFinger.MakeZerosFailTable(spellID, text, roles)
	if FailTable.Data[spellID..text] == nil then
		local _,_,_,_,_,_,_,_, instanceSize = GetInstanceInfo() -- Needed to handle if people leave the group
		HardFinger.InstanceSize = instanceSize
		for i=1, instanceSize do
			local tempUnitName = UnitName(HardFinger.ValidUnitFrameGUID..i)
			if string.find(string.upper(roles),UnitGroupRolesAssigned(tempUnitName)) or roles == "ALL" then
					HardFinger.ModifyFailTable(spellID, text, tempUnitName, 0)
			end
		end
	end
end

function HardFinger.DPrint(...)
	if UnitName("player") == "Eumesminha" or UnitName("player") == "Camoleze" then
		print(...)
	end
end

function HardFinger.ComputeSterilize()
	for player, innerTable in pairs(HardFinger.SterilizeTable) do
		HardFinger.DPrint("\nComputing for player..", player)
		result = innerTable.count * 2.5 / innerTable.buffUptime * 100
		result = format("%.1f", result)
		HardFinger.ModifyFailTable(208499, "Score! (higher is better): ", HardFinger.SName(player), nil, tonumber(result))
	end
	wipe(SterilizeTable)
end



-- Funo raid target flags ICONs
function HardFinger.GetRaidMarkByFlags(flags)
    if flags == 0 or flags == nil then
        return "" 
    end
    local r = log(flags)/log(2) + 1
    markName = "NONE"
    if r == 1 then
        markName = "STAR"
    elseif r == 6 then
        markName = "SQUARE"
    elseif r == 7 then
        markName = "CROSS"
    elseif r == 8 then
        markName = "SKULL"
    end
    return " {rt"..r.."} ",  MarkName
end

-- Funo HP Porcentagem
function HardFinger.Hpp(unit)
	return math.max(0, UnitHealth(unit)) / math.max(1, UnitHealthMax(unit)) * 100;
end