local HardFinger = _G.HardFinger

local P = HardFinger.HardFinger_Config
--------------------------------------------------------------------------------------------------------
--                                          Left Buttons                                              --
--------------------------------------------------------------------------------------------------------
local activePage = 1;
local frames = {};
HardFinger.options = {
	-- General
	{
		[0] = "General",
		[1] = { type = "Check", var = "Status", label = "STATUS - Toggles the addon on/off", tip = "y" },
		[2] = { type = "Check", var = "WhoPulled", label = "WHOPULLED - Announces who aggroed non-friendly mobs", tip = "The first spell debuff, spell damage or melee swing on each non-friendly mob will be announced on the proper channnel", y = 0 },
			[8] = { type = "DropDown", var = "WhoPulledChannel", label = "Channel:", attachTo = 2, listName = "ListOfChannels" },
		[3] = { type = "Check", var = "BloodLust", label = "BLOODLUST - Announces who used Blood Lust (and similars) or Drums", tip = "" },
		[4] = { type = "Check", var = "BattleRez", label = "BATTLE REZ - Announces the source and destination from used battle rezzes", tip = "" },
		[5] = { type = "Check", var = "Taunt", label = "TAUNT - Announces taunts", tip = "y" },
		--[6] = { type = "Check", var = "TimeToDie", label = "[NYI] TIME TO DIE - Shows estimation of how long it will take for your target to die", tip = "" , y = 50},
		[6] = { type = "Check", var = "DisableAddonLFR", label = "Check this to disable HardFinger while inside a LFR instance.", tip = "" , y = 50},

		[7] = { type = "DropDown", var = "ReportChannel", label = "Report Channel:", listName = "ListOfChannels", y = 5},
		--{ type = "DropDown", var = "showRealm", label = "Show Unit Realm", list = { ["Do not show realm"] = "none", ["Show realm"] = "show", ["Show (*) instead"] = "asterisk" } },
		--{ type = "DropDown", var = "showTarget", label = "Show Unit Target", list = { ["Do not show target"] = "none", ["First line"] = "first", ["Second line"] = "second", ["Last line"] = "last" }, y = 16 },
		--{ type = "Text", id=8, var = "targetYouText", label = "Targeting You Text" },
	},
	-- General
	{
		[0] = "Dungeons",
		[1] = { type = "DropDown", page = 2, type2 = "ParentDropDown", var = "dropDownSelectedInstance",
		label = "Select Dungeon:", list = { --["Vault of the Wardens"] = "Vault of the Wardens",
										["Eye of Azshara"] = "Eye of Azshara",
--										["Karazhan"] = "Karazhan",
--										["Maw of Souls"] = "Maw of Souls"
		}   },
	},
	{
		[0] = "Trial of Valor",
		[1] = { type = "DropDown", page = 3, type2 = "ParentDropDown", var = "dropDownSelectedBoss",
		label = "Select Boss:", list = { ["1. Odyn"] = "Odyn",
										["2. Guarm"] = "Guarm",
										["3. Helya"] = "Helya"}  },
	},
	{
		[0] = "Night Hold",
		[1] = { type = "DropDown", page = 4, type2 = "ParentDropDown", var = "dropDownSelectedBoss",
		label = "Select Boss:", list = { ["1. Skorpyron"] = "Skorpyron",
										["2. Chronomatic Anomaly"] = "Chronomatic Anomaly",
										["3. Trilliax"] = "Trilliax",
										["4. Spellblade Aluriel"] = "Spellblade Aluriel",
										["5. Tichondrius"] = "Tichondrius",
										["6. Krosus"] = "Krosus",
										["7. High Botanist Tel'arn"] = "High Botanist Tel'arn",
										["8. Star Augur Etraeus"] = "Star Augur Etraeus",
										["9. Elisande"] = "Elisande",
										["10. Gul'dan"] = "Gul'dan"} },
	},
	{
		[0] = "Tomb of Sargeras",
		[1] = { type = "DropDown", page = 5, type2 = "ParentDropDown", var = "dropDownSelectedBoss",
		label = "Select Boss:", list = { ["1. Goroth"] = "Goroth", 
										["2. Demonic Inquisition"] = "Demonic Inquisition",
										["3. Harjatan"] = "Harjatan",
										["4. Mistress Sassz'ine"] = "Mistress Sassz'ine",
										["6. Sisters of the Moon"] = "Sisters of the Moon",
										["5. The Desolate Host"] = "The Desolate Host",
										["7. Maiden of Vigilance"] = "Maiden of Vigilance",
										["8. Fallen Avatar"] = "Fallen Avatar",
										["9. Kil'jaeden"] = "Kil'jaeden"} },
	},
}
options = HardFinger.options

function HardFinger.UpdateOptions(page, id, variableToChange, newValue)
	options[page][id][variableToChange] = newValue
	return
end
--------------------------------------------------------------------------------------------------------
--                                          Initialize Frame                                          --
--------------------------------------------------------------------------------------------------------

--function HardFinger.InitiliazeOptionsFrame()
local f = CreateFrame("Frame","HardFingerOptions",UIParent);

f.options = options;

f:SetWidth(780);
f:SetHeight(500);	-- "18" per category entry
f:SetBackdrop({ bgFile = "Interface\\ChatFrame\\ChatFrameBackground", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 16, edgeSize = 16, insets = { left = 3, right = 3, top = 3, bottom = 3 } });
f:SetBackdropColor(0.1,0.22,0.35,0.85);
f:SetBackdropBorderColor(0.1,0.1,0.1,0.85);
f:EnableMouse(true);
f:SetMovable(true);
f:SetFrameStrata("DIALOG");
f:SetToplevel(true);
f:SetClampedToScreen(true);
f:SetScript("OnShow",function() f:BuildCategoryPage(); end);
f:Hide();

f.outline = CreateFrame("Frame",nil,f);
f.outline:SetBackdrop({ bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
f.outline:SetBackdropColor(0.1,0.1,0.2,1);
f.outline:SetBackdropBorderColor(0.8,0.8,0.9,0.4);
f.outline:SetPoint("TOPLEFT",12,-12);
f.outline:SetPoint("BOTTOMLEFT",12,12);
f.outline:SetWidth(130);

f:SetScript("OnMouseDown",function() f:StartMoving() end);
f:SetScript("OnMouseUp",function() f:StopMovingOrSizing(); P.optionsLeft = f:GetLeft(); P.optionsBottom = f:GetBottom(); end);

if (P.optionsLeft) and (P.optionsBottom) then
	f:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",P.optionsLeft,P.optionsBottom);
else
	f:SetPoint("CENTER");
end

f.header = f:CreateFontString(nil,"ARTWORK","GameFontHighlight");
f.header:SetFont(GameFontNormal:GetFont(),22,"THICKOUTLINE");
f.header:SetPoint("TOPLEFT",f.outline,"TOPRIGHT",10,-4);
f.header:SetText("HardFinger - Options");

f.vers = f:CreateFontString(nil,"ARTWORK","GameFontNormal");
f.vers:SetPoint("TOPRIGHT",-20,-20);
f.vers:SetText(GetAddOnMetadata("HardFinger","Version"));
f.vers:SetTextColor(1,1,0.5);

local function Reset_OnClick(self)
	for index, tbl in ipairs(options[activePage]) do
		if (tbl.var) then
			P[tbl.var] = nil;
		end
	end
	f:BuildCategoryPage();
end

--f.btnAnchor = CreateFrame("Button",nil,f,"UIPanelButtonTemplate");
--f.btnAnchor:SetWidth(75);
--f.btnAnchor:SetHeight(24);
--f.btnAnchor:SetPoint("BOTTOMLEFT",f.outline,"BOTTOMRIGHT",10,3);
--f.btnAnchor:SetScript("OnClick",function() if (TipTac:IsVisible()) then TipTac:Hide(); else TipTac:Show(); end end);
--f.btnAnchor:SetText("Anchor");

f.btnReset = CreateFrame("Button",nil,f,"UIPanelButtonTemplate");
f.btnReset:SetWidth(75);
f.btnReset:SetHeight(24);
f.btnReset:SetPoint("BOTTOMLEFT",f.outline,"BOTTOMRIGHT",10,3);
f.btnReset:SetScript("OnClick", Reset_OnClick);
f.btnReset:SetText("Defaults");

f.btnDisplayFailTable = CreateFrame("Button",nil,f,"UIPanelButtonTemplate");
f.btnDisplayFailTable:SetWidth(120);
f.btnDisplayFailTable:SetHeight(24);
f.btnDisplayFailTable:SetPoint("LEFT",f.btnReset,"RIGHT",113,0);
f.btnDisplayFailTable:SetScript("OnClick",HardFinger.DisplayFailTable);
f.btnDisplayFailTable:SetText("Report Fail Table");

f.btnClose = CreateFrame("Button",nil,f,"UIPanelButtonTemplate");
f.btnClose:SetWidth(75);
f.btnClose:SetHeight(24);
f.btnClose:SetPoint("BOTTOMRIGHT",-15,15);
f.btnClose:SetScript("OnClick",function() f:Hide() HardFinger.SaveVariables(); end);
f.btnClose:SetText("Close");

UISpecialFrames[#UISpecialFrames + 1] = f:GetName();

--end

--------------------------------------------------------------------------------------------------------
--                                        Options Category List                                       --
--------------------------------------------------------------------------------------------------------

local listButtons = {};

local function List_OnClick(self,button)
	listButtons[activePage].text:SetTextColor(1,0.82,0);
	listButtons[activePage]:UnlockHighlight();
	activePage = self.index;
	self.text:SetTextColor(1,1,1);
	self:LockHighlight();
	PlaySound("igMainMenuOptionCheckBoxOn");
	f:BuildCategoryPage();
end

local buttonWidth = (f.outline:GetWidth() - 8);
local function MakeListEntry()
	local b = CreateFrame("Button",nil,f.outline);
	b:SetWidth(buttonWidth);
	b:SetHeight(18);
	b:SetScript("OnClick",List_OnClick);
	b:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight");
	b:GetHighlightTexture():SetAlpha(0.7);
	b.text = b:CreateFontString(nil,"ARTWORK","GameFontNormal");
	b.text:SetPoint("LEFT",3,0);
	listButtons[#listButtons + 1] = b;
	return b;
end

local button;
for index, table in ipairs(options) do
	button = listButtons[index] or MakeListEntry();
	button.text:SetText(table[0]);
	button.index = index;
	if (index == 1) then
		button:LockHighlight();
		button.text:SetTextColor(1,1,1);
		button:SetPoint("TOPLEFT",f.outline,"TOPLEFT",5,-6);
	else
		button:SetPoint("TOPLEFT",listButtons[index - 1],"BOTTOMLEFT");
	end
end

--------------------------------------------------------------------------------------------------------
--                                        Build Option Category                                       --
--------------------------------------------------------------------------------------------------------

local function ChangeSettingFunc(self, var, value, bossName)
	if (not ignoreConfigUpdate) then
		if bossName ~= nil then
			P["EncountersOptions"] = P["EncountersOptions"] or {};
			P["EncountersOptions"][bossName] = P["EncountersOptions"][bossName] or {};
			P["EncountersOptions"][bossName][var] = value;
		else
			P[var] = value;
		end
	end
end

local factory = HFAzOptionsFactory:New(f,nil,ChangeSettingFunc);

-- Build Page
function HardFinger.GUI()
	f:BuildCategoryPage();
	--HardFinger.DPrint("f:BuildCategoryPage() called")
end

function f:BuildCategoryPage()
	HFAzDropDown:HideMenu();
	factory:ResetObjectUse();
	local frame;
	local yOffset = -38;
	-- Loop Through Options
	ignoreConfigUpdate = 1;
	
	for index, option in ipairs(options[activePage]) do
		--print(index, option)
		if option.label ~= "" then -- Skip iteration if object is meant to be invisible
			-- Init & Setup the Frame
			frame = factory:GetObject(option.type, #(option.label));			-- Get the size of the label string for proper anchoring
			frame.option = option;
			frame.text:SetText(option.label);
			-- slider
			if (option.type == "Slider") then
				frame.slider:SetMinMaxValues(option.min,option.max);
				frame.slider:SetValueStep(option.step);
				frame.slider:SetValue(P[option.var]);
				frame.edit:SetNumber(P[option.var]);
				frame.low:SetText(option.min);
				frame.high:SetText(option.max);
			-- check
			elseif (option.type == "Check") then
				frame:SetHitRectInsets(0,frame.text:GetWidth() * -1,0,0);
				if option.bossName ~= nil then
					if (P.EncountersOptions[option.bossName][option.var]) == nil then
						frame:SetChecked(false);
					else
						frame:SetChecked(P.EncountersOptions[option.bossName][option.var]);
					end
				else
					frame:SetChecked(P[option.var]);
				end
			-- color
			elseif (option.type == "Color") then
				frame:SetHitRectInsets(0,frame.text:GetWidth() * -1,0,0);
				if (option.subType == 2) then
					frame.color[1], frame.color[2], frame.color[3], frame.color[4] = factory:HexStringToRGBA(P[option.var]);
				else
					frame.color[1], frame.color[2], frame.color[3], frame.color[4] = unpack(P[option.var]);
				end
				frame.texture:SetVertexColor(frame.color[1],frame.color[2],frame.color[3],frame.color[4] or 1);
			-- dropdown
			elseif (option.type == "DropDown") then
	--			frame.InitFunc = (option.init or option.media and HardFingerDropDowns.SharedMediaLib_Init or HardFingerDropDowns.Default_Init);
				frame.InitFunc = HardFingerDropDowns.Default_Init;
				
				if option.bossName ~= nil then
					frame:InitSelectedItem(P.EncountersOptions[option.bossName][option.var]);
				else
					frame:InitSelectedItem(P[option.var]);
				end
			-- text
			elseif (option.type == "Text") then
				if option.bossName ~= nil then
					frame:SetText(P.EncountersOptions[option.bossName][option.var]);
				else
					--frame:InitSelectedItem(P[option.var]);
				end
			end
			-- Anchor the Frame
			frame:ClearAllPoints();
			
			-- Register X,Y positioning and width
			option.xpos = factory.objectOffsetX[option.type] + (option.x or 0)
			option.ypos = yOffset
			option.width = frame.text:GetStringWidth()

			if option.attachTo ~= nil then
				xpos = options[activePage][option.attachTo].xpos + 50 + options[activePage][option.attachTo].width + frame.text:GetStringWidth()
				ypos = options[activePage][option.attachTo].ypos
				frame:SetPoint("TOPLEFT",f.outline,"TOPRIGHT",xpos,ypos)
			else
				frame:SetPoint("TOPLEFT",f.outline,"TOPRIGHT",option.xpos,yOffset);
				yOffset = (yOffset - frame:GetHeight() - factory.objectOffsetY[option.type] - (option.y or 0));
			end
			-- Show
			frame:Show();
		end
	end
	-- End Update
	ignoreConfigUpdate = nil;
end